"use strict";

const Service = require("egg").Service;

class ImageService extends Service {
  /**
   * 保存图片
   * @param {*} showPath 图片展示路径
   * @param {*} dicomInfo dicom信息
   * @param {*} user_id user_id
   */
  findAndUpsert(dicomInfo, user_id) {
    return this.ctx.model.Image.findOneAndUpdate({
      InstanceNumber: dicomInfo.InstanceNumber,
      SeriesInstanceUID: dicomInfo.SeriesInstanceUID,
      user_id: user_id,
    }, {
      ...dicomInfo,
      pathUpload: false,
      pngUpload: false
    }, {
      new: true,
      upsert: true,
      setDefaultsOnInsert: true
    }).exec();
  }
}
module.exports = ImageService;